ON_PlaneSurface Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_planesurface.h>`

Inheritance diagram for ON_PlaneSurface:

## Public Member Functions

| ON_PlaneSurface ()
| ON_PlaneSurface (const ON_PlaneSurface &)
ON_PlaneSurface & | operator= (const ON_PlaneSurface &)
| ON_PlaneSurface (const ON_Plane &)
ON_PlaneSurface & | operator= (const ON_Plane &)
virtual | ~ON_PlaneSurface ()
unsigned int | SizeOf () const
ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
int | Dimension () const
ON_BOOL32 | GetBBox (double *, double *, ON_BOOL32=false) const
ON_BOOL32 | Transform (const ON_Xform &)
ON_BOOL32 | SetDomain (int dir, double t0, double t1)
ON_Interval | Domain (int) const
ON_BOOL32 | GetSurfaceSize (double *width, double *height) const
int | SpanCount (int) const
ON_BOOL32 | GetSpanVector (int, double *) const
int | Degree (int) const
ON_BOOL32 | GetParameterTolerance (int, double, double *, double *) const
ON_BOOL32 | IsPlanar (ON_Plane *plane=NULL, double tolerance=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsClosed (int) const
ON_BOOL32 | IsPeriodic (int) const
ON_BOOL32 | IsSingular (int) const
bool | GetNextDiscontinuity (int dir, ON::continuity c, double t0, double t1, double *t, int *hint=NULL, int *dtype=NULL, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
bool | IsContinuous (ON::continuity c, double s, double t, int *hint=NULL, double point_tolerance=ON_ZERO_TOLERANCE, double d1_tolerance=ON_ZERO_TOLERANCE, double d2_tolerance=ON_ZERO_TOLERANCE, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
ON_BOOL32 | Reverse (int)
ON_BOOL32 | Transpose ()
ON_BOOL32 | Evaluate (double, double, int, int, double *, int=0, int *=0) const
ON_Curve * | IsoCurve (int dir, double c) const
ON_BOOL32 | Trim (int dir, const ON_Interval &domain)
bool | Extend (int dir, const ON_Interval &domain)
ON_BOOL32 | Split (int dir, double c, ON_Surface *&west_or_south_side, ON_Surface *&east_or_north_side) const
bool | GetClosestPoint (const ON_3dPoint &P, double *s, double *t, double maximum_distance=0.0, const ON_Interval *sdomain=0, const ON_Interval *tdomain=0) const
ON_BOOL32 | GetLocalClosestPoint (const ON_3dPoint &, double, double, double *, double *, const ON_Interval *=NULL, const ON_Interval *=NULL) const
ON_Surface * | Offset (double offset_distance, double tolerance, double *max_deviation=NULL) const
int | GetNurbForm (ON_NurbsSurface &, double=0.0) const
int | HasNurbForm () const
bool | SetExtents (int dir, ON_Interval extents, bool bSynchDomain=false)
ON_Interval | Extents (int dir) const
bool | CreatePseudoInfinitePlane (ON_PlaneEquation plane_equation, const ON_BoundingBox &bbox, double padding=0.0625)
bool | CreatePseudoInfinitePlane (const ON_Plane &plane, const ON_BoundingBox &bbox, double padding=0.0625)
bool | CreatePseudoInfinitePlane (const ON_Plane &plane, int point_count, const ON_3dPoint *point_list, double padding=0.0625)
Public Member Functions inherited from ON_Surface
void | DestroyRuntimeCache (bool bDelete=true)
| ON_Surface ()
| ON_Surface (const ON_Surface &)
ON_Surface & | operator= (const ON_Surface &)
virtual | ~ON_Surface ()
unsigned int | SizeOf () const
bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
virtual ON_Surface * | DuplicateSurface () const
ON::object_type | ObjectType () const
ON_BOOL32 | HasBrepForm () const
ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
ON_BOOL32 | GetDomain (int dir, double *t0, double *t1) const
bool | SetDomain (int dir, ON_Interval domain)
virtual ON_BOOL32 | GetSpanVectorIndex (int dir, double t, int side, int *span_vector_index, ON_Interval *span_interval) const
virtual ISO | IsIsoparametric (const ON_Curve &curve, const ON_Interval *curve_domain=NULL) const
virtual ISO | IsIsoparametric (const ON_BoundingBox &bbox) const
bool | IsSphere (ON_Sphere *sphere=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsCylinder (ON_Cylinder *cylinder=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsCone (ON_Cone *cone=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsTorus (ON_Torus *torus=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsSolid () const
bool | IsAtSingularity (double s, double t, bool bExact=true) const
int | IsAtSeam (double s, double t) const
ON_3dPoint | PointAt (double, double) const
ON_3dVector | NormalAt (double, double) const
ON_BOOL32 | FrameAt (double u, double v, ON_Plane &frame) const
ON_BOOL32 | EvPoint (double u, double v, ON_3dPoint &point, int quadrant=0, int *hint=0) const
ON_BOOL32 | Ev1Der (double u, double v, ON_3dPoint &point, ON_3dVector &du, ON_3dVector &dv, int quadrant=0, int *hint=0) const
ON_BOOL32 | Ev2Der (double u, double v, ON_3dPoint &point, ON_3dVector &du, ON_3dVector &dv, ON_3dVector &duu, ON_3dVector &duv, ON_3dVector &dvv, int quadrant=0, int *hint=0) const
ON_BOOL32 | EvNormal (double u, double v, ON_3dPoint &point, ON_3dVector &normal, int quadrant=0, int *hint=0) const
ON_BOOL32 | EvNormal (double u, double v, ON_3dVector &normal, int quadrant=0, int *hint=0) const
ON_BOOL32 | EvNormal (double u, double v, ON_3dPoint &point, ON_3dVector &du, ON_3dVector &dv, ON_3dVector &normal, int=0, int *=0) const
ON_NurbsSurface * | NurbsSurface (ON_NurbsSurface *pNurbsSurface=NULL, double tolerance=0.0, const ON_Interval *s_subdomain=NULL, const ON_Interval *t_subdomain=NULL) const
virtual bool | GetSurfaceParameterFromNurbFormParameter (double nurbs_s, double nurbs_t, double *surface_s, double *surface_t) const
virtual bool | GetNurbFormParameterFromSurfaceParameter (double surface_s, double surface_t, double *nurbs_s, double *nurbs_t) const
void | DestroySurfaceTree ()
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
virtual void | ClearBoundingBox ()
virtual bool | IsDeformable () const
virtual bool | MakeDeformable ()
virtual ON_BOOL32 | SwapCoordinates (int i, int j)
virtual ON_COMPONENT_INDEX | ComponentIndex () const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)

## Public Attributes

ON_Plane | m_plane

## Protected Attributes

ON_Interval | m_domain [2]
ON_Interval | m_extents [2]

## Additional Inherited Members

Public Types inherited from ON_Surface
enum | ISO { not_iso = 0, x_iso = 1, y_iso = 2, W_iso = 3, S_iso = 4, E_iso = 5, N_iso = 6, iso_count = 7 }

## Detailed Description

Definition at line 22 of file opennurbs_planesurface.h.

## Constructor & Destructor Documentation

## ON_PlaneSurface() [1/3]

ON_PlaneSurface::ON_PlaneSurface | ( |  | ) |

## ON_PlaneSurface() [2/3]

ON_PlaneSurface::ON_PlaneSurface | ( | const ON_PlaneSurface & |  | ) |

## ON_PlaneSurface() [3/3]

ON_PlaneSurface::ON_PlaneSurface | ( | const ON_Plane & |  | ) |

## ~ON_PlaneSurface()

virtual ON_PlaneSurface::~ON_PlaneSurface | ( |  | ) |

virtual

## Member Function Documentation

## CreatePseudoInfinitePlane() [1/3]

bool ON_PlaneSurface::CreatePseudoInfinitePlane | ( | ON_PlaneEquation | plane_equation,
|  | const ON_BoundingBox & | bbox,
|  | double | padding = `0.0625`
| ) |  |

## CreatePseudoInfinitePlane() [2/3]

bool ON_PlaneSurface::CreatePseudoInfinitePlane | ( | const ON_Plane & | plane,
|  | const ON_BoundingBox & | bbox,
|  | double | padding = `0.0625`
| ) |  |

## CreatePseudoInfinitePlane() [3/3]

bool ON_PlaneSurface::CreatePseudoInfinitePlane | ( | const ON_Plane & | plane,
|  | int | point_count,
|  | const ON_3dPoint * | point_list,
|  | double | padding = `0.0625`
| ) |  |

## DataCRC()

ON__UINT32 ON_PlaneSurface::DataCRC | ( | ON__UINT32 | current_remainder | ) | const

virtual

Reimplemented from ON_Object.

Reimplemented in ON_ClippingPlaneSurface.

## Degree()

int ON_PlaneSurface::Degree | ( | int |  | ) | const

virtual

Implements ON_Surface.

## Dimension()

int ON_PlaneSurface::Dimension | ( |  | ) | const

virtual

Implements ON_Geometry.

## Domain()

ON_Interval ON_PlaneSurface::Domain | ( | int |  | ) | const

virtual

Implements ON_Surface.

## Dump()

void ON_PlaneSurface::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

Reimplemented in ON_ClippingPlaneSurface.

## Evaluate()

ON_BOOL32 ON_PlaneSurface::Evaluate | ( | double | ,
|  | double | ,
|  | int | ,
|  | int | ,
|  | double * | ,
|  | int | = `0`,
|  | int * | = `0`
| ) |  | const

virtual

Implements ON_Surface.

## Extend()

bool ON_PlaneSurface::Extend | ( | int | dir,
|  | const ON_Interval & | domain
| ) |  |

virtual

Reimplemented from ON_Surface.

## Extents()

ON_Interval ON_PlaneSurface::Extents | ( | int | dir | ) | const

## GetBBox()

ON_BOOL32 ON_PlaneSurface::GetBBox | ( | double * | ,
|  | double * | ,
|  | ON_BOOL32 | = `false`
| ) |  | const

virtual

Implements ON_Geometry.

## GetClosestPoint()

bool ON_PlaneSurface::GetClosestPoint | ( | const ON_3dPoint & | P,
|  | double * | s,
|  | double * | t,
|  | double | maximum_distance = `0.0`,
|  | const ON_Interval * | sdomain = `0`,
|  | const ON_Interval * | tdomain = `0`
| ) |  | const

## GetLocalClosestPoint()

ON_BOOL32 ON_PlaneSurface::GetLocalClosestPoint | ( | const ON_3dPoint & | ,
|  | double | ,
|  | double | ,
|  | double * | ,
|  | double * | ,
|  | const ON_Interval * | = `NULL`,
|  | const ON_Interval * | = `NULL`
| ) |  | const

## GetNextDiscontinuity()

bool ON_PlaneSurface::GetNextDiscontinuity | ( | int | dir,
|  | ON::continuity | c,
|  | double | t0,
|  | double | t1,
|  | double * | t,
|  | int * | hint = `NULL`,
|  | int * | dtype = `NULL`,
|  | double | cos_angle_tolerance = `ON_DEFAULT_ANGLE_TOLERANCE_COSINE`,
|  | double | curvature_tolerance = `ON_SQRT_EPSILON`
| ) |  | const

virtual

Reimplemented from ON_Surface.

## GetNurbForm()

int ON_PlaneSurface::GetNurbForm | ( | ON_NurbsSurface & | ,
|  | double | = `0.0`
| ) |  | const

virtual

Reimplemented from ON_Surface.

## GetParameterTolerance()

ON_BOOL32 ON_PlaneSurface::GetParameterTolerance | ( | int | ,
|  | double | ,
|  | double * | ,
|  | double * |
| ) |  | const

virtual

Reimplemented from ON_Surface.

## GetSpanVector()

ON_BOOL32 ON_PlaneSurface::GetSpanVector | ( | int | ,
|  | double * |
| ) |  | const

virtual

Implements ON_Surface.

## GetSurfaceSize()

ON_BOOL32 ON_PlaneSurface::GetSurfaceSize | ( | double * | width,
|  | double * | height
| ) |  | const

virtual

Reimplemented from ON_Surface.

## HasNurbForm()

int ON_PlaneSurface::HasNurbForm | ( |  | ) | const

virtual

Reimplemented from ON_Surface.

## IsClosed()

ON_BOOL32 ON_PlaneSurface::IsClosed | ( | int |  | ) | const

virtual

Reimplemented from ON_Surface.

## IsContinuous()

bool ON_PlaneSurface::IsContinuous | ( | ON::continuity | c,
|  | double | s,
|  | double | t,
|  | int * | hint = `NULL`,
|  | double | point_tolerance = `ON_ZERO_TOLERANCE`,
|  | double | d1_tolerance = `ON_ZERO_TOLERANCE`,
|  | double | d2_tolerance = `ON_ZERO_TOLERANCE`,
|  | double | cos_angle_tolerance = `ON_DEFAULT_ANGLE_TOLERANCE_COSINE`,
|  | double | curvature_tolerance = `ON_SQRT_EPSILON`
| ) |  | const

virtual

Reimplemented from ON_Surface.

## IsoCurve()

ON_Curve* ON_PlaneSurface::IsoCurve | ( | int | dir,
|  | double | c
| ) |  | const

virtual

Reimplemented from ON_Surface.

## IsPeriodic()

ON_BOOL32 ON_PlaneSurface::IsPeriodic | ( | int |  | ) | const

virtual

Reimplemented from ON_Surface.

## IsPlanar()

ON_BOOL32 ON_PlaneSurface::IsPlanar | ( | ON_Plane * | plane = `NULL`,
|  | double | tolerance = `ON_ZERO_TOLERANCE`
| ) |  | const

virtual

Reimplemented from ON_Surface.

## IsSingular()

ON_BOOL32 ON_PlaneSurface::IsSingular | ( | int |  | ) | const

virtual

Reimplemented from ON_Surface.

## IsValid()

ON_BOOL32 ON_PlaneSurface::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

## Offset()

ON_Surface* ON_PlaneSurface::Offset | ( | double | offset_distance,
|  | double | tolerance,
|  | double * | max_deviation = `NULL`
| ) |  | const

## operator=() [1/2]

ON_PlaneSurface& ON_PlaneSurface::operator= | ( | const ON_PlaneSurface & |  | ) |

## operator=() [2/2]

ON_PlaneSurface& ON_PlaneSurface::operator= | ( | const ON_Plane & |  | ) |

## Read()

ON_BOOL32 ON_PlaneSurface::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Object.

Reimplemented in ON_ClippingPlaneSurface.

## Reverse()

ON_BOOL32 ON_PlaneSurface::Reverse | ( | int |  | ) |

virtual

Implements ON_Surface.

## SetDomain()

ON_BOOL32 ON_PlaneSurface::SetDomain | ( | int | dir,
|  | double | t0,
|  | double | t1
| ) |  |

virtual

Reimplemented from ON_Surface.

## SetExtents()

bool ON_PlaneSurface::SetExtents | ( | int | dir,
|  | ON_Interval | extents,
|  | bool | bSynchDomain = `false`
| ) |  |

## SizeOf()

unsigned int ON_PlaneSurface::SizeOf | ( |  | ) | const

virtual

Reimplemented from ON_Object.

Reimplemented in ON_ClippingPlaneSurface.

## SpanCount()

int ON_PlaneSurface::SpanCount | ( | int |  | ) | const

virtual

Implements ON_Surface.

## Split()

ON_BOOL32 ON_PlaneSurface::Split | ( | int | dir,
|  | double | c,
|  | ON_Surface *& | west_or_south_side,
|  | ON_Surface *& | east_or_north_side
| ) |  | const

virtual

Reimplemented from ON_Surface.

## Transform()

ON_BOOL32 ON_PlaneSurface::Transform | ( | const ON_Xform & |  | ) |

virtual

Reimplemented from ON_Geometry.

## Transpose()

ON_BOOL32 ON_PlaneSurface::Transpose | ( |  | ) |

virtual

Implements ON_Surface.

## Trim()

ON_BOOL32 ON_PlaneSurface::Trim | ( | int | dir,
|  | const ON_Interval & | domain
| ) |  |

virtual

Reimplemented from ON_Surface.

## Write()

ON_BOOL32 ON_PlaneSurface::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Object.

Reimplemented in ON_ClippingPlaneSurface.

## Member Data Documentation

## m_domain

ON_Interval ON_PlaneSurface::m_domain[2]

protected

Definition at line 611 of file opennurbs_planesurface.h.

## m_extents

ON_Interval ON_PlaneSurface::m_extents[2]

protected

Definition at line 614 of file opennurbs_planesurface.h.

## m_plane

ON_Plane ON_PlaneSurface::m_plane

Definition at line 45 of file opennurbs_planesurface.h.

The documentation for this class was generated from the following file:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_planesurface.h